<?php


namespace MirfalahTech\Laravel\Payment\Gateway\DummyPay;


use Illuminate\Contracts\Config\Repository;
use Illuminate\Contracts\Container\BindingResolutionException;
use Illuminate\Support\ServiceProvider;
use MirfalahTech\Laravel\Payment\Manager\PaymentManager;

class DummyPayServiceProvider extends ServiceProvider
{
    /**
     * @throws BindingResolutionException
     */
    public function boot()
    {
        /** @var Repository $config */
        $config = $this->app->make('config');

        $config->set('payment.gateway.dummy', array_merge(
            [
                'callback_url' => env('DUMMYPAY_CALLBACK'),
                'return_url' => env('DUMMYPAY_RETURN'),
            ],
            $config->get('payment.gateway.dummy', [])
        ));

        $this->app->afterResolving('payment', function (PaymentManager $manager) use ($config) {
            $manager->extend('dummy', function () use ($config) {
                return new DummyPayDriver(
                    $config->get('payment.gateway.dummy.callback_url'),
                    $config->get('payment.gateway.dummy.return_url')
                );
            });
        });
    }
}